unit Unit2;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, System.Generics.Collections,
  VclTee.TeeGDIPlus, VCLTee.TeEngine, Vcl.ExtCtrls, VCLTee.TeeProcs,
  VCLTee.Chart, VCLTee.TeeTools, Vcl.StdCtrls, VCLTee.Series;

type
  TForm2 = class(TForm)
    Chart1: TChart;
    Panel1: TPanel;
    btnUpdateChart: TButton;
    Series1: TBarSeries;
    procedure btnUpdateChartClick(Sender: TObject);
    procedure Chart1BeforeDrawSeries(Sender: TObject);
  private
    { Private declarations }
    FBands: TObjectList<TColorBandTool>;
    procedure UpdateChart;
    procedure UpdateBands;
  public
    { Public declarations }
    constructor Create(aOwner: TComponent); override;
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

{ TForm2 }

constructor TForm2.Create(aOwner: TComponent);
begin
  inherited;

  FBands := TObjectList<TColorBandTool>.Create;
  UpdateChart;
end;

procedure TForm2.btnUpdateChartClick(Sender: TObject);
begin
  UpdateChart;
end;

procedure TForm2.Chart1BeforeDrawSeries(Sender: TObject);
begin
  UpdateBands;
end;

procedure TForm2.UpdateBands;
const
  BAND_SIZE = 7;
var
  lBand: TColorBandTool;
  lStartValue: Double;
  lMax: Double;
begin
  lStartValue := 0;
  lMax := Chart1.BottomAxis.Maximum;
  while lStartValue < lMax do
  begin
    lBand := TColorBandTool.Create(self);
    lBand.ParentChart := Chart1;
    lBand.Axis := Chart1.BottomAxis;
    lBand.StartValue := lStartValue;
    lBand.EndValue := lBand.StartValue + BAND_SIZE;
    if FBands.Count = 2 then
      lBand.Color := clYellow
    else
      lBand.Color := clWhite;

    FBands.Add(lBand);

    lStartValue := lStartValue + BAND_SIZE;
  end;

  Caption := Format('Bands Created: %d; Max Value: %.4f', [FBands.COunt, Chart1.BottomAxis.Maximum]);
end;

procedure TForm2.UpdateChart;
var
  lValue: Double;
  I: Integer;
begin
  FBands.Clear;
  Series1.Clear;

  lValue := 1000.0;
  for I := 1 to 30 do
  begin
    Series1.Add(lValue);
    lValue := lValue * 1.03;
  end;
  Caption := 'not done';

end;

end.
